package asm

import (
	"fmt"
)

// Number operates with just a number.
type Number struct {
	Number int
}

// String returns a human readable version.
func (data *Number) String() string {
	return fmt.Sprintf("%d", data.Number)
}

// Number adds an instruction with a number.
func (a *Assembler) Number(mnemonic Mnemonic, number int) {
	a.Instructions = append(a.Instructions, Instruction{
		Mnemonic: mnemonic,
		Data: &Number{
			Number: number,
		},
	})
}
