package compiler

import "os"

// Write writes an executable file to disk.
func (r *Result) WriteFile(path string) error {
	file, err := os.Create(path)

	if err != nil {
		return err
	}

	err = r.Write(file)

	if err != nil {
		file.Close()
		return err
	}

	err = file.Close()

	if err != nil {
		return err
	}

	return os.Chmod(path, 0755)
}
